Subject: bug#9807: custom libtool installation and automake testsuite failures (was: Re: [PATCH] tests: avoid false positive due to change in --help formatting)

From: Stefano Lattarini <[email-masked]>
Date: Sun, 6 Nov 2011 16:54:53 +0100

Hi Jim.

On Sunday 06 November 2011, Jim Meyering wrote:
> Stefano Lattarini wrote:
> > On Friday 04 November 2011, Stefano Lattarini wrote:
> >> On Friday 04 November 2011, Stefano Lattarini wrote:
> >> >
> >> > [SNIP]
> >> >
> >> > Attached is a patch in this spirit; I'll push in a few hours if there is
> >> > no objection.
> >> >
> > Pushed now.
> 
> Thanks.
> 
> With that, I would have had no test failures on master, but now I
> have 20+.  The cause is that in the mean time I've installed a private
> copy of libtool-2.4.2, while parts of the test seem to expect the
> version installed as /usr/bin/libtool: 2.4:
> 
>     libtool: Version mismatch error.  This is libtool 2.4.2, but the
>     libtool: definition of this LT_INIT comes from libtool 2.4.
>     libtool: You should recreate aclocal.m4 with macros from libtool 2.4.2
>     libtool: and run autoconf again.
>     make: *** [libd.lo] Error 63
>
Hmmm... my guess is that the automake testsuite is finding and using
the system-wide versions of the libtool macros, instead of the ones
of your custom libtool installation; see also automake bug#9807:
 <http://debbugs.gnu.org/cgi/bugreport.cgi?bug=9807>
(which I'm CC'ing, for reference).  This sucks, and will hopefully
be fixed in the first automake release after 1.11.2 (either 1.12 or
1.11.3).

Just to verify this hunch of mine is correct, can you tell me how
you've configured automake, where you have installed your private
libtool version, and post the logs of the failing test(s)?

> Should I expect those tests to pass in this case?
>
For the moment, I *think* (hope?) that you can work around the
problem as follows:

  $ cd ~/src/automake # Directory of your automake checkout.
  $ mkdir _inst
  $ ./configure --prefix=`pwd`/_inst
  $ make install
  $ cat > _inst/share/aclocal/dirlist <<END
  # Directory of your libtool macros from your custom libtool
  # installation.
  /opt/libtool-2.4.2/share/aclocal
  # Directory of your system-wide third-party aclocal macros.
  /usr/share/aclocal
  END

Let me know how this works out.

Thanks,
  Stefano